protected/models/Dataset.php
<?php
Yii::import('application.extensions.CAdvancedArBehavior');

class Dataset extends MyActiveRecord
{
    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return Dataset the static model class
     */
    
    const DATASET_PRIVATE = 'Private';
    
    const URL_RIS = 'http://data.datacite.org/application/x-research-info-systems/10.5524/';
    const URL_BIBTEXT = 'http://data.datacite.org/application/x-bibtex/10.5524/';
    const URL_TEXT = 'http://data.datacite.org/application/x-datacite+text/10.5524/';

    public $dTypes="";
    public $commonNames="";
    public $email;
    public $union;
    public $types;

    public static $statusList = array('Incomplete'=>'Incomplete',
                         'Request'=>'Request',
                         'Uploaded'=>'Uploaded',                                               
                         'Pending'=>'Pending',
                         'Private'=>'Private',
                         'Published'=>'Published'
                         );

    /*
     * List of Many To Many RelationShip
     */

    public $new_ext_acc_mirror;
    public $new_ext_acc_link;

#    public $projectIDs = array();
#    public $authorIDs = array();
#    public $sampleIDs = array();
#    public $datasetTypeIDs = array();

    public static function model($className=__CLASS__)
    {
        return parent::model($className);
    }

#    public function behaviors(){
#          return array( 'CAdvancedArBehavior' => array(
#                'class' => 'application.extensions.CAdvancedArBehavior'));
#    }

    /**
     * @return string the associated database table name
     */
    public function tableName()
    {
        return 'dataset';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules()
    {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('submitter_id, identifier, title, dataset_size, ftp_site', 'required'),
            array('submitter_id, image_id, publisher_id', 'numerical', 'integerOnly'=>true),
            array('dataset_size', 'numerical'),
            array('identifier, excelfile_md5', 'length', 'max'=>32),
            array('title', 'length', 'max'=>300),
            array('upload_status', 'length', 'max'=>45),
            array('ftp_site', 'length', 'max'=>100),
            array('excelfile', 'length', 'max'=>50),
            array('description, publication_date, modification_date, image_id, fairnuse, types', 'safe'),
            // The following rule is used by search().
            // Please remove those attributes that should not be searched.
            array('id, submitter_id, image_id, identifier, title, description, publisher, dataset_size, ftp_site, upload_status, excelfile, excelfile_md5, publication_date, modification_date', 'safe', 'on'=>'search'),
#            array('projectIDs , sampleIDs , authorIDs , datasetTypeIDs' , 'safe'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'authors' => array(self::MANY_MANY, 'Author', 'dataset_author(dataset_id,author_id)', 'order'=>'authors.first_name ASC', ),
            'projects' => array(self::MANY_MANY, 'Project', 'dataset_project(dataset_id,project_id)'),
            'submitter' => array(self::BELONGS_TO, 'User', 'submitter_id'),
            'image' => array(self::BELONGS_TO, 'Images', 'image_id'),
            'samples' => array(self::MANY_MANY, 'Sample', 'dataset_sample(dataset_id,sample_id)'),
            'externalLinks' => array(self::HAS_MANY, 'ExternalLink', 'dataset_id'),
            'datasetTypes' => array(self::MANY_MANY, 'Type', 'dataset_type(dataset_id,type_id)'),
            'files' => array(self::HAS_MANY, 'File', 'dataset_id'),
            'relations' => array(self::HAS_MANY, 'Relation', 'dataset_id'),
            'links' => array(self::HAS_MANY, 'Link', 'dataset_id'),
            'manuscripts' => array(self::HAS_MANY, 'Manuscript', 'dataset_id'),
            'publisher' => array(self::BELONGS_TO, 'Publisher', 'publisher_id'),
            'datasetFunders'=>array(self::HAS_MANY, 'DatasetFunder', 'dataset_id'),
            'funders' =>array(self::HAS_MANY, 'Funder', 'dataset_funder(dataset_id, funder_id)'),
            'datasetLogs'=>array(self::HAS_MANY, 'DatasetLog', 'dataset_id'),
            'datasetAttributes' => array(self::HAS_MANY, 'DatasetAttributes', 'dataset_id'),
            'attributes' => array(self::MANY_MANY, 'Attribute', 'dataset_attributes(dataset_id, attribute_id)'), 
        );
    }

    public function getPolicy() {
        $att = Attribute::model()->findByAttributes(array('attribute_name'=>Attribute::FUP));
        if(!$att)
            return null;
        return DatasetAttributes::model()->findByAttributes(array('dataset_id'=>$this->id, 'attribute_id'=>$att->id));
    }

    public function getSamplesInIds($ids) {
        $crit = new CDbCriteria;
        $crit->join = "join dataset_sample ds on ds.sample_id = t.id";
        $crit->condition = "ds.dataset_id = :id";
        $crit->params = array(':id'=>$this->id); 
        $crit->addInCondition("t.id", $ids);             
        return Sample::model()->findAll($crit);
    }

    public function getFilesInIds($ids) {
        $crit = new CDbCriteria;
        $crit->condition = "dataset_id = :id";
        $crit->params = array(':id'=>$this->id); 
        $crit->addInCondition("id", $ids);               
        return File::model()->findAll($crit);
    }

    public function getPreviousDoi() {
        return Dataset::model()->find(array('condition' =>"identifier < :id and upload_status = 'Published'", 
                'params'=>array(':id'=>$this->identifier),
                'order'=>'identifier desc'
        ));
    }

    public function getNextDoi() {
        return Dataset::model()->find(array('condition' =>"identifier > :id and upload_status = 'Published'", 
                'params'=>array(':id'=>$this->identifier),
                'order'=>'identifier asc'
        ));
    }

    public function getCited() {
        $identifier = $this->identifier;
        $phrase = "10.5524/$identifier";
        $citeds = Utils::searchScholar($phrase);
        $sum = 0;
        if($citeds)
            $sum = count($citeds);       
        $url = Yii::app()->params['scholar_query'].$phrase;
        return array('total'=>$sum, 'url'=>$url);
    }

    public function getGoogleScholarLink() {
        return Yii::app()->params['scholar_query']."10.5524/".$this->identifier;
    }

    public function getEPMCLink() {
        return  Yii::app()->params['ePMC_query']."(REF:'10.5524/".$this->identifier."')";
    } 

    public static function clearDatasetSession() {
        $vars = array('dataset', 'images', 'authors', 'projects',
            'links', 'externalLinks', 'relations', 'samples', 'dataset_id', 'identifier', 'filecount',
            'link_database', 'isOld');
        foreach ($vars as $var) {
            unset($_SESSION[$var]);
            //    $_SESSION[$var] = CJSON::decode($dataset_session->$var);
        }

    }

    public function getAuthorNames() {
        $criteria = new CDbCriteria;
        $criteria->join = 'left join author a on a.id = t.author_id';
        $criteria->addCondition('t.dataset_id ='.$this->id);
        $criteria->order= 't.rank ASC, a.surname ASC, a.first_name ASC, a.middle_name ASC';
        $das = DatasetAuthor::model()->findAll($criteria);

        $l = array();
        foreach($das as $da) {
            $author = $da->author;
            $name = $author->displayName;
            $id = $author->id;
            $l[] = CHtml::link($name, "/search/new?keyword=$name&author_id=$id", array('class'=>'result-sub-links'));
        }
        return implode('; ', $l);
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels()
    {
        return array(
            'id' => 'ID',
            'submitter_id' => 'Submitter',
            'image_id' => 'Image',
            'identifier' => 'DOI',
            'title' => Yii::t('app' ,'Title'),
            'description' => 'Description',
            'publisher' => 'Publisher',
            'dataset_size' => 'Dataset Size',
            'ftp_site' => 'Ftp Site',
            'upload_status' => 'Upload Status',
            'excelfile' => 'Excelfile',
            'excelfile_md5' => 'Excelfile Md5',
            'publication_date' => Yii::t('app' ,'Publication Date'),
            'modification_date' => Yii::t('app' , 'Modification Date'),
            'new_image_url' => 'Image URL',
            'new_image_location' => 'Image Location',
            'fairnuse' => 'Fair Use Policy',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
     */
    public function search()
    {
        // Warning: Please modify the following code to remove attributes that
        // should not be searched.

        $criteria=new CDbCriteria;

        $criteria->compare('id',$this->id);
        $criteria->compare('submitter_id',$this->submitter_id);
        $criteria->compare('image_id',$this->image_id);
        $criteria->compare('LOWER(identifier)',strtolower($this->identifier),true);
        $criteria->compare('LOWER(title)',strtolower($this->title),true);
        $criteria->compare('LOWER(description)',strtolower($this->description),true);
        $criteria->compare('LOWER(publisher)',strtolower($this->publisher_id),true);

protected/controllers/SearchController.php
<?php

class SearchController extends Controller
{
    public $layout='//layouts/column2';

    public function actionEmailNewDatasets() {
        $this->render('emailNewDatasets');
    }

    public function actionEmailMatchedSearches() {
        $this->render('emailMatchedSearches');
    }

    /* return CActiveRecords */
    private function getFullFileResultByKeyword($fileIds) {
        $temp_file_criteria = new CDbCriteria();
        $temp_file_criteria->addInCondition("id", $fileIds);
        return File::model()->findAll($temp_file_criteria);
    }

    private function getFullDatasetResultByKeyword($keyword) {
        $wordCriteria=array();
        $wordCriteria['keyword']=$keyword;
        $list_result_dataset_criteria = $this->searchDataset($wordCriteria);
        $temp_dataset_criteria = new CDbCriteria();
        $temp_dataset_criteria->addInCondition("id", $list_result_dataset_criteria);
        return Dataset::model()->findAll($temp_dataset_criteria);
    }

    public function actionRedirect($id){
        $criteria = SearchRecord::model()->findByPk($id);
        if($criteria==null){
            throw new CHttpException(500,'The requested record does not exist.') ;
        }else {
            $criteria=json_decode($criteria->query,true);
            $params=array();
            $params[]='search/index';
            foreach ($criteria as $key => $value) {
                if(stristr($key, "date")){
                    $params[$key]= str_replace("/", "-", $value);
                }else {
                    $params[$key]=$value;
                }

            }
            $this->redirect($params);
        }
    }

	public function actionSave() {
		$result = array();

		if (Yii::app()->user->isGuest) {
			$result['status'] = "fail";
			$result['reason'] = "You must log in to save search query";
		} else {
			$criteriaStr = $_POST['criteria'];
			$criteria = CJSON::decode($criteriaStr, true);
			if (isset($criteria['keyword']) && strlen($criteria['keyword']) > 0) {
				
				$search = new SearchRecord;
				$search->user_id = Yii::app()->user->_id;
				$search->name = $criteria['keyword'];
				$search->query = $_POST['criteria'];
				$search->result = $_POST['result'];

				if ($search->save()) {
					$result['status'] = "success";
				} else {
					$result['status'] = "fail";
					$result['reason'] = "Unknown Reason";
				}

			} else {
				$result['status'] = "fail";
				$result['reason'] = "Problem with search query, pls check";
			}
		}
		echo json_encode($result);
	}

	public function actionDelete() {
		$id = $_POST['id'];
		$result = array();
		$model = SearchRecord::model()->findByPk($id);
		if ($model) {
			if ($model->user_id == Yii::app()->user->getId()) {
				if ($model->delete()) {
					$result['status'] = "success";
					$result['id'] = $id;
				} else {
					$result['status'] = "fail";
					$result['reason'] = "Unknown Error occur";
				}

			} else {
				$result['status'] = "fail";
				$result['reason'] = "This record does not belongs to you";
			}

		} else {
			$result['status'] = "fail";
			$result['reason'] = "Record Not Found";

		}

		echo json_encode($result);
	}

    
    public function actionNew($keyword = '') {       
        $ds = new DatabaseSearch();        
        $offset = 0;
        $limit = 10;
        $page = 1;
        $data = $ds->searchByKey($keyword);

        if(!Yii::app()->request->isPostRequest) {          
            $datasets = $data['datasets'];
            $datasets['data'] = array_slice($datasets['data'], $offset, $limit);
            $data['datasets'] = $datasets;
            $this->render('new', $data);
        }

        else {            
            try {
                $page = intVal($_POST['page']);
            }
            catch (Exception $e) {
                $page = 1;
            }
            

            $offset = ($page-1)*$limit;
            $datasets = $data['datasets'];
            $datasets['data'] = array_slice($datasets['data'], $offset, $limit);
            $data['datasets'] = $datasets;
            $data['page'] = $page;           

            $result = $this->renderPartial('_new_result', array(
                'model' => $data['model'],
                'datasets' => $data['datasets'],
                'samples' => $data['samples'],
                'files' => $data['files'],
                'display' => $data['display']
            ), true, false); 

            $filter = $this->renderPartial('_new_filter', array(
                'model' => $data['model'],
                'list_dataset_types' => $data['list_dataset_types'],
                'list_projects' => $data['list_projects'],
                'list_ext_types' => $data['list_ext_types'],
                'list_filetypes' => $data['list_filetypes'],
                'list_formats' => $data['list_formats'],
                'list_common_names' => $data['list_common_names']
            ), true, false);

            $range = $this->renderPartial('_range', array(
                            'total_dataset'=>$data['datasets']['total'],
                            'page'=>$data['page'],
                            'limit'=>$data['limit']
                        ), true, false);

            echo CJSON::encode(array('success'=>true, 'filter'=>$filter, 'result'=>$result, 'range'=>$range));
            Yii::app()->end();
        }    
    }

}

protected/views/search/_author.php
<div class="tab-content">
	<?php foreach($datasets as $dataset) { ?>
	<div class="search-result-container">
		<!--Dataset section-->		
		<div class="row">
			<div class="span1 logo-container"><img src="/images/icons/g.png"></div>
			<div class="span8 main-content">
				<ul class="nav nav-tabs nav-stacked result-cell">
				  <li><a data-content="<?php echo MyHtml::encode($dataset->description) ?>" class="result-main-link left content-popup" href="/dataset/<?= $dataset->identifier?>"><?= $dataset->title ?></a></li>
				  <li>
				  	<strong>
				  		<?= $dataset->authorNames ?>
				  	</strong>
				  </li>
				  <li class="searchID"><?= Yii::t('app', 'DOI') ?>:<?php echo "10.5524/" . $dataset->identifier ?></li>
				</ul>
			</div>
		</div>
		<?php /* foreach($dataset->samples as $sample) { ?>
		<!--Sample section-->
		<div class="row">
			<div class="span1 logo-container"><img src="/images/icons/s.png"></div>
			<div class="span8 main-content">
				<ul class="nav nav-tabs nav-stacked result-cell">
				  <li><a href="http://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?mode=Info&id=<?php echo $sample->species->tax_id ?>"><?php echo $sample->name ?></a></li>
				  <li>
				  	<strong>
						<a class="result-sub-links" href="#"><?php echo $sample->species->common_name ?></a> 
						NCBI taxonomy : <?php echo $sample->species->tax_id ?>
				  	</strong>
				  </li>
				  <li class="searchID">DOI:10.5524/<?= $sample->dataset->identifier ?></li>
				</ul>
			</div>
		</div>
		<?php } ?>
		<!--Download File list-->
		<?php foreach($dataset->files as $file) { ?>
		<div class="row file-container">
			<div class="span1 logo-container-file"><img src="/images/icons/f.png"> </div>
			<div class="span3 file-name"><a href="<?php echo $file->location ?>"><?php echo strlen($file->name) > 20 ? substr($file->name, 0, 20). '...' : $file->name ?></a></div>
			<div class="span2 file-type"><?php echo $file->type->name ?></div>
			<div class="span2 file-size"><?php echo MyHtml::encode(File::staticBytesToSize($file->size))?></div>
			<div class="span1 file-checkbox"><input type="checkbox" ></div>
		</div>
		<?php } */?>
	</div>		
	<div style="clear:both;"></div>	
	<br/>
	<?php } ?>	
</div>

protected/views/search/_new_result.php
<div class="tab-content">
    <?php foreach($datasets['data'] as $dt) { ?>
    <?php 
        $dataset = Dataset::model()->findByPk($dt); 
        $dsamples = $dataset->getSamplesInIds($samples['data']);
        $dfiles = $dataset->getFilesInIds($files['data']); 
    ?>
    <div class="search-result-container">
        <!--Dataset section-->
        <?php $is_display = in_array('dataset', $display) || (in_array('file', $display) && $dfiles) || (in_array('sample', $display) && $dsamples); ?>
        <?php if($is_display) { ?>
        <div class="row">
            <div class="span1 logo-container"><img src="/images/icons/g-new-icon.png">
            </div>
            <div class="span8 main-content">
                <ul class="nav nav-tabs nav-stacked result-cell">
                  <li><a data-content="<?php echo MyHtml::encode($dataset->description) ?>" class="result-main-link left content-popup" href="<?= $dataset->shortUrl ?>"><?= $dataset->title ?></a></li>
                  <li>
                    <strong>
                        <?php echo $dataset->authorNames ?>
                    </strong>
                  </li>
                  <li class="searchID"><?= Yii::t('app', 'DOI') ?>:<?php echo "10.5524/" . $dataset->identifier ?></li>
                </ul>
            </div>
        </div>
        <?php } ?>

        <?php if(in_array('sample', $display)) { 
            foreach($dsamples as $sample) { ?>
            <!--Sample section-->
            <div class="row">
                <div class="span1 logo-container"><img src="/images/icons/s-new-icon.png"></div>
                <div class="span8 main-content">
                    <ul class="nav nav-tabs nav-stacked result-cell">
                      <li><a class="result-main-link" href="<?= $sample->dataset->shortUrl ?>"><?php echo $sample->name ?></a></li>
                      <li>
                        <strong>
                            <?= $sample->species->common_name ?> 
                            NCBI taxonomy : 
                            <a class="result-sub-links" target="_blank" href="http://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?mode=Info&id=<?php echo $sample->species->tax_id ?>">
                                <?= $sample->species->tax_id ?>
                            </a>
                        </strong>
                      </li>
                      <li class="searchID"><a class="result-sub-links" href="<?= $sample->dataset->shortUrl ?>">DOI:10.5524/<?= $sample->dataset->identifier ?></a></li>
                    </ul>
                </div>
            </div>
            <?php }} ?>
            <!--Download File list-->
            <?php if(in_array('file', $display)) {
                foreach($dfiles as $file) { ?>
            <div class="row file-container">
                <div class="span1 logo-container-file"><img src="/images/icons/f-new-icon.png"> </div>
                <div class="span3 file-name"><a href="<?php echo $file->location ?>"><?php echo strlen($file->name) > 20 ? substr($file->name, 0, 20). '...' : $file->name ?></a></div>
                <div class="span2 file-type"><?php echo $file->type->name ?></div>
                <div class="span2 file-size"><?php echo MyHtml::encode(File::staticBytesToSize($file->size))?></div>
                <div class="span1 file-checkbox"><input type="checkbox" ></div>
            </div>
            <?php }} ?>
	</div>
		
	<div style="clear:both;"></div>	
	<br/>
	<?php } ?>	
</div>

protected/views/search/_range.php
<?php 
	$from = ($page-1) * $limit + 1;
	$to = $page*$limit; 
?>
<p>
    Showing 
    <?php if($from <= $total_dataset) { ?>
    <strong><?= $from?> - <?= $to > $total_dataset ? $total_dataset: $to ?> of <?= $total_dataset ?></strong> datasets 
    <?php } ?>
</p>

protected/views/search/_result.php
<div class="tab-content">
    <?php foreach($datasets['data'] as $dt) { ?>
    <?php $dataset = Dataset::model()->findByPk($dt); ?>
    <div class="search-result-container">
        <!--Dataset section-->
        <?php if(in_array('dataset', $display)) { ?>
        <div class="row">
            <div class="span1 logo-container"><img src="/images/icons/G_clipart1.png"></div>
            <div class="span8 main-content">
                <ul class="nav nav-tabs nav-stacked result-cell">
                  <li><a data-content="<?php echo MyHtml::encode($dataset->description) ?>" class="result-main-link left content-popup" href="/dataset/<?= $dataset->identifier?>"><?= $dataset->title ?></a></li>
                  <li>
                    <strong>
                        <?= $dataset->authorNames ?>
                    </strong>
                  </li>
                  <li class="searchID"><?= Yii::t('app', 'DOI') ?>:<?php echo "10.5524/" . $dataset->identifier ?></li>
                </ul>
            </div>
        </div>
        <?php } ?>

        <?php 
            $dsamples = $dataset->getSamplesInIds($samples['data']);
            $dfiles = $dataset->getFilesInIds($files['data']); 
        ?>

            <?php if(in_array('sample', $display)) { 
                    foreach($dsamples as $sample) { ?>
            <!--Sample section-->
            <div class="row">
                <div class="span1 logo-container"><img src="/images/icons/S_clipart1.png"></div>
                <div class="span8 main-content">
                    <ul class="nav nav-tabs nav-stacked result-cell">
                      <li><a href="http://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?mode=Info&id=<?php echo $sample->species->tax_id ?>"><?php echo $sample->name ?></a></li>
                      <li>
                        <strong>
                            <a class="result-sub-links" href="#"><?php echo $sample->species->common_name ?></a> 
                            NCBI taxonomy : <?php echo $sample->species->tax_id ?>
                        </strong>
                      </li>
                      <li class="searchID">DOI:10.5524/<?= $sample->dataset->identifier ?></li>
                    </ul>
                </div>
            </div>
            <?php }} ?>
            <!--Download File list-->
            <?php if(in_array('file', $display)) {
                foreach($dfiles as $file) { ?>
            <div class="row file-container">
                <div class="span1 logo-container-file"><img src="/images/icons/F_clipart1.png"> </div>
                <div class="span3 file-name"><a href="<?php echo $file->location ?>"><?php echo strlen($file->name) > 20 ? substr($file->name, 0, 20). '...' : $file->name ?></a></div>
                <div class="span2 file-type"><?php echo $file->type->name ?></div>
                <div class="span2 file-size"><?php echo MyHtml::encode(File::staticBytesToSize($file->size))?></div>
                <div class="span1 file-checkbox"><input type="checkbox" ></div>
            </div>
            <?php }} ?>
	</div>
		
	<div style="clear:both;"></div>	
	<br/>
	<?php } ?>	
</div>

protected/views/search/_search.php
<div class="row">
    <div class="span12">
    <?php echo MyHtml::beginForm('/search/new','GET',array('class'=>'form-search well','onsubmit'=>'return validateForm(this);')); ?>
    <?php echo MyHtml::errorSummary($model); ?>
    <?php

        $this->widget('zii.widgets.jui.CJuiAutoComplete', array(
            'name'=>'keyword',
            //'source'=>array('ac1', 'ac2', 'ac3'),
            // 'source'=> array_values($dataset->getListTitles()),
            'source'=> array_values(array()),
            // additional javascript options for the autocomplete plugin
            'options'=>array(
                 'minLength'=>'2',
             ),
            'htmlOptions'=>array(
                 'class'=>'span7 offset1',
             ),
             'value'=>$model->keyword
        ));

        echo MyHtml::submitButton(Yii::t('app' , 'Search again'), array('class'=>'span2 btn-green'));
        if(!Yii::app()->user->isGuest) {
            
            echo MyHtml::ajaxButton(Yii::t('app' , 'Save current search criteria'),array("/search/save"),array('type'=>'POST','dataType'=>'json','data'=>array('criteria'=>$model->criteria, 'result'=>$model->query_result) ,'success'=>"function(data){
                if(data.status=='fail'){
                    alert('Failed to save: '+ data.reason);
                }else {
                    alert('Successfully save search query');
                }
            }") ,array('class'=>'span3 btn'));
        }
    ?>


    <?php echo MyHtml::endForm(); ?>

    </div>
</div>

<div id="saveSearchStatus" >
    <div id="saveSearchSuccess" style="display:none">
        <h2>Success</h2>
    </div>
    <div id="saveSearchFail" style="display:none">
        <h2>Opps!</h2>
        <h2 id="saveSearchReason">Reason</h2>
    </div>
</div>
<script>
function validateForm(myform){
    if(myform.keyword.value.length==0) {
        alert("Keyword can not be blank");
        return false;
    }

    return true;

}


// function submitForm(myform){
//     var strJson= JSON.stringify($(myform).serializeObject());

//     var searchform=myform['searchform'].value;


//     var url=window.location.protocol+"//"+window.location.hostname+(window.location.port ? ':'+window.location.port: '')+$(myform).attr("action");

//     window.location = url+"?criteria=" + strJson;



//     return false;

// }

// $.fn.serializeObject = function()
// {
//     var o = {};
//     var a = this.serializeArray();
//     $.each(a, function() {
//         if (o[this.name] !== undefined) {
//             if (!o[this.name].push) {
//                 o[this.name] = [o[this.name]];
//             }
//             o[this.name].push(this.value || '');
//         } else {
//             o[this.name] = this.value || '';
//         }
//     });
//     return o;
// };

</script>

protected/views/search/author.php
<?php //There are search results ?>

<h3 class="search-result-title">Search result for <span><i><?= $author->name ?></i></span></h3>

<div class="row" id="form_result">
    <div class="span3" id="filter">
        
    </div>

    <div class="offset3 span9 result" id="result">
        <!--<span class='pull-right'><?= Yii::t('app', 'Selected all files') ?> <input type="checkbox" class="select-all"/></span> -->
        <?php $this->renderPartial("_author", array(
            'datasets' => $datasets
        )) ?>
    </div>

</div>
<div class="row">
    <div class="span9 offset3">
        <ul id="search-pg" class="pagination-sm"></ul>
    </div>
</div>

<script>
    $(".hint").tooltip({'placement':'left'});
    $(".content-popup").popover({'placement':'right'});
    $('#myTab a').click(function (e) {
        e.preventDefault();
        $(this).tab('show');
        var rel=$(this).attr("rel");
        $(rel).show();
        if(rel=="#file_filter"){
            //window.location.hash="#result_files";
            $("#filter_tab").val("#result_files");
            $("#dataset_filter").hide();
        }else if(rel=="#dataset_filter"){
            $("#file_filter").hide();
            //window.location.hash="#result_dataset";
            $("#filter_tab").val("#result_dataset");
        }

    });

    if(window.location.hash=="#result_files"){
        $("#myTab a[href='#result_files']").tab("show");
        $("#file_filter").show();
        $("#dataset_filter").hide();

    }
</script>

protected/views/search/invalid.php
<div class="row">
    <div class="center">
    <? if( isset($general_search)) {?>
        Your search for "<?echo $keyword ?>" did not match anything in our database, please try a 
        different term.
    <? } else {?>
    The DOI <? echo $keyword ?> cannot be displayed. <br/>
   If you found reference to this DOI in a publication, please <b>Let us know.</b>
   
    <? } ?>
    </div>
</div>
<div class="clear"></div>
<?
// There are search results
$this->renderPartial('_form', array('model' => $model));

?>

<div class="center">
    <a href="/" class="btn-green">GigaDB home</a>
</div>